package nc.impl.bd.auditnew.service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import nc.bs.framework.common.NCLocator;
import nc.impl.bd.auditnew.cache.CashFlowDataCache;
import nc.impl.bd.auditnew.cache.CurrencyDataCache;
import nc.impl.bd.auditnew.cache.GlNumberFormat;
import nc.impl.bd.auditnew.cache.OrgBookCorpTransCatch;
import nc.impl.gl.jaxb.GLCashFlowVoucherRefType;
import nc.impl.gl.jaxb.StringType;
import nc.itf.bd.auditnew.service.IDealQueryData;
import nc.itf.fi.pub.Vouchertype;
import nc.itf.gl.dealQueryData.IGBRemoteQueryData;
import nc.vo.bd.b18.VouchertypeVO;
import nc.vo.bd.b60.CashflowVO;
import nc.vo.gl.GBExportVO.CashFlowExpVO;
import nc.vo.gl.GBExportVO.ExportConditionVO;

public class GLCashFlowVoucherQueryData implements IDealQueryData {

   public List getQueryData(ExportConditionVO conditionVO) throws Exception {
      ArrayList cashflowVouerList = new ArrayList();
      IGBRemoteQueryData iq = (IGBRemoteQueryData)NCLocator.getInstance().lookup(IGBRemoteQueryData.class.getName());
      List bslist = iq.getCashFlowVoucherQueryData(conditionVO);
      if(bslist != null && bslist.size() > 0) {
         new Vouchertype();
         VouchertypeVO[] tempvos = Vouchertype.queryAll((String)null);
         Hashtable vouchetype = new Hashtable();

         for(int subRef = 0; subRef < tempvos.length; ++subRef) {
            vouchetype.put(tempvos[subRef].getPk_vouchertype(), tempvos[subRef]);
         }

         GLCashFlowVoucherRefType var14 = null;
         StringType stringType = null;
         HashMap cashflowCodeMap = new HashMap();
         Iterator var10 = bslist.iterator();

         while(var10.hasNext()) {
            CashFlowExpVO cashflowVo = (CashFlowExpVO)var10.next();
            var14 = new GLCashFlowVoucherRefType();
            stringType = new StringType();
            stringType.setValue(((VouchertypeVO)vouchetype.get(cashflowVo.getPk_vouchertype())).getForshort().toString());
            var14.setVouchertypeCode(stringType);
            stringType = new StringType();
            stringType.setValue(cashflowVo.getVoucherno());
            var14.setVoucherNo(stringType);
            stringType = new StringType();
            stringType.setValue(CurrencyDataCache.getInstance().getCurrtypeBypk(cashflowVo.getM_pk_currtype()).getCurrtypecode().toString());
            var14.setCurrytypeCode(stringType);
            stringType = new StringType();
            if(cashflowCodeMap.get(cashflowVo.getPk_voucher()) != null) {
               int pk_corp = ((Integer)cashflowCodeMap.get(cashflowVo.getPk_voucher())).intValue() + 1;
               stringType.setValue("" + pk_corp);
               cashflowCodeMap.put(cashflowVo.getPk_voucher(), new Integer(pk_corp));
            } else {
               byte var15 = 1;
               stringType.setValue("" + var15);
               cashflowCodeMap.put(cashflowVo.getPk_voucher(), new Integer(var15));
            }

            var14.setCashflowhcode(stringType);
            stringType = new StringType();
            stringType.setValue(cashflowVo.getMemo());
            var14.setCashflowExp(stringType);
            stringType = new StringType();
            String var16 = OrgBookCorpTransCatch.getInstance().getPk_CorpByPk_orgbook(cashflowVo.getPk_glorgbook());
            CashflowVO cfv = CashFlowDataCache.getInstance().getCashflowVOByPkcorpandPk(var16, cashflowVo.getPk_cashflow());
            stringType.setValue(cfv.getCfitemcode());
            var14.setCashflowItemCode(stringType);
            stringType = new StringType();
            stringType.setValue(cfv.getItemflag());
            var14.setCashflowItemProp(stringType);
            stringType = new StringType();
            stringType.setValue(GlNumberFormat.formatUFDouble(cashflowVo.getMoney(), 2).toString());
            var14.setCashflowAmount(stringType);
            stringType = new StringType();
            stringType.setValue(GlNumberFormat.formatUFDouble(cashflowVo.getMoneymain(), 2).toString());
            var14.setCashflowLocalAmount(stringType);
            cashflowVouerList.add(var14);
         }
      }

      return cashflowVouerList;
   }
}
